Chat
ChatCompletions
Given a list of messages comprising a conversation, the model will return a response.
Create chat completion
List Chat Completions
Get chat completion
Update chat completion
Delete chat completion
ModelsExpand Collapse
class ChatCompletion: …Represents a chat completion response returned by model, based on the provided input.
Represents a chat completion response returned by model, based on the provided input.
choices: List[Choice]A list of chat completion choices. Can be more than one if n is greater than 1.
A list of chat completion choices. Can be more than one if n is greater than 1.
finish_reason: Literal["stop", "length", "tool_calls", 2 more]The reason the model stopped generating tokens. This will be stop if the model hit a natural stop point or a provided stop sequence,
length if the maximum number of tokens specified in the request was reached,
content_filter if content was omitted due to a flag from our content filters,
tool_calls if the model called a tool, or function_call (deprecated) if the model called a function.
The reason the model stopped generating tokens. This will be stop if the model hit a natural stop point or a provided stop sequence,
length if the maximum number of tokens specified in the request was reached,
content_filter if content was omitted due to a flag from our content filters,
tool_calls if the model called a tool, or function_call (deprecated) if the model called a function.
logprobs: Optional[ChoiceLogprobs]Log probability information for the choice.
Log probability information for the choice.
A list of message content tokens with log probability information.
A list of message content tokens with log probability information.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value -9999.0 is used to signify that the token is very unlikely.
top_logprobs: List[TopLogprob]List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
A list of message refusal tokens with log probability information.
A list of message refusal tokens with log probability information.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value -9999.0 is used to signify that the token is very unlikely.
top_logprobs: List[TopLogprob]List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
service_tier: Optional[Literal["auto", "default", "flex", 2 more]]Specifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
Specifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
class ChatCompletionAssistantMessageParam: …Messages sent by the model in response to user messages.
Messages sent by the model in response to user messages.
audio: Optional[Audio]Data about a previous audio response from the model.
Learn more.
Data about a previous audio response from the model. Learn more.
content: Optional[Union[str, List[ContentArrayOfContentPart], null]]The contents of the assistant message. Required unless tool_calls or function_call is specified.
The contents of the assistant message. Required unless tool_calls or function_call is specified.
List[ContentArrayOfContentPart]An array of content parts with a defined type. Can be one or more of type text, or exactly one of type refusal.
An array of content parts with a defined type. Can be one or more of type text, or exactly one of type refusal.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
Deprecatedfunction_call: Optional[FunctionCall]Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
An optional name for the participant. Provides the model information to differentiate between participants of the same role.
The tool calls generated by the model, such as function calls.
The tool calls generated by the model, such as function calls.
class ChatCompletionMessageFunctionToolCall: …A call to a function tool created by the model.
A call to a function tool created by the model.
function: FunctionThe function that the model called.
The function that the model called.
class ChatCompletionAudio: …If the audio output modality is requested, this object contains data
about the audio response from the model. Learn more.
If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
class ChatCompletionAudioParam: …Parameters for audio output. Required when audio output is requested with
modalities: ["audio"]. Learn more.
Parameters for audio output. Required when audio output is requested with
modalities: ["audio"]. Learn more.
format: Literal["wav", "aac", "mp3", 3 more]Specifies the output audio format. Must be one of wav, mp3, flac,
opus, or pcm16.
Specifies the output audio format. Must be one of wav, mp3, flac,
opus, or pcm16.
class ChatCompletionChunk: …Represents a streamed chunk of a chat completion response returned
by the model, based on the provided input.
Learn more.
Represents a streamed chunk of a chat completion response returned by the model, based on the provided input. Learn more.
choices: List[Choice]A list of chat completion choices. Can contain more than one elements if n is greater than 1. Can also be empty for the
last chunk if you set stream_options: {"include_usage": true}.
A list of chat completion choices. Can contain more than one elements if n is greater than 1. Can also be empty for the
last chunk if you set stream_options: {"include_usage": true}.
delta: ChoiceDeltaA chat completion delta generated by streamed model responses.
A chat completion delta generated by streamed model responses.
Deprecatedfunction_call: Optional[ChoiceDeltaFunctionCall]Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
role: Optional[Literal["developer", "system", "user", 2 more]]The role of the author of this message.
The role of the author of this message.
tool_calls: Optional[List[ChoiceDeltaToolCall]]
function: Optional[ChoiceDeltaToolCallFunction]
finish_reason: Optional[Literal["stop", "length", "tool_calls", 2 more]]The reason the model stopped generating tokens. This will be stop if the model hit a natural stop point or a provided stop sequence,
length if the maximum number of tokens specified in the request was reached,
content_filter if content was omitted due to a flag from our content filters,
tool_calls if the model called a tool, or function_call (deprecated) if the model called a function.
The reason the model stopped generating tokens. This will be stop if the model hit a natural stop point or a provided stop sequence,
length if the maximum number of tokens specified in the request was reached,
content_filter if content was omitted due to a flag from our content filters,
tool_calls if the model called a tool, or function_call (deprecated) if the model called a function.
logprobs: Optional[ChoiceLogprobs]Log probability information for the choice.
Log probability information for the choice.
A list of message content tokens with log probability information.
A list of message content tokens with log probability information.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value -9999.0 is used to signify that the token is very unlikely.
top_logprobs: List[TopLogprob]List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
A list of message refusal tokens with log probability information.
A list of message refusal tokens with log probability information.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value -9999.0 is used to signify that the token is very unlikely.
top_logprobs: List[TopLogprob]List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The Unix timestamp (in seconds) of when the chat completion was created. Each chunk has the same timestamp.
service_tier: Optional[Literal["auto", "default", "flex", 2 more]]Specifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
Specifies the processing type used for serving the request.
- If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'.
- If set to 'default', then the request will be processed with the standard pricing and performance for the selected model.
- If set to 'flex' or 'priority', then the request will be processed with the corresponding service tier.
- When not set, the default behavior is 'auto'.
When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.
This fingerprint represents the backend configuration that the model runs with.
Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism.
An optional field that will only be present when you set
stream_options: {"include_usage": true} in your request. When present, it
contains a null value except for the last chunk which contains the
token usage statistics for the entire request.
NOTE: If the stream is interrupted or cancelled, you may not receive the final usage chunk which contains the total token usage for the request.
Learn about text inputs.
Learn about text inputs.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
class ChatCompletionContentPartImage: …Learn about image inputs.
Learn about image inputs.
image_url: ImageURL
detail: Optional[Literal["auto", "low", "high"]]Specifies the detail level of the image. Learn more in the Vision guide.
Specifies the detail level of the image. Learn more in the Vision guide.
class ChatCompletionContentPartInputAudio: …Learn about audio inputs.
Learn about audio inputs.
class File: …Learn about file inputs for text generation.
Learn about file inputs for text generation.
class ChatCompletionContentPartImage: …Learn about image inputs.
Learn about image inputs.
image_url: ImageURL
detail: Optional[Literal["auto", "low", "high"]]Specifies the detail level of the image. Learn more in the Vision guide.
Specifies the detail level of the image. Learn more in the Vision guide.
class ChatCompletionContentPartInputAudio: …Learn about audio inputs.
Learn about audio inputs.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
class ChatCompletionCustomTool: …A custom tool that processes input using a specified format.
A custom tool that processes input using a specified format.
class ChatCompletionDeveloperMessageParam: …Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
class ChatCompletionMessage: …A chat completion message generated by the model.
A chat completion message generated by the model.
annotations: Optional[List[Annotation]]Annotations for the message, when applicable, as when using the
web search tool.
Annotations for the message, when applicable, as when using the web search tool.
If the audio output modality is requested, this object contains data about the audio response from the model. Learn more.
Deprecatedfunction_call: Optional[FunctionCall]Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
The tool calls generated by the model, such as function calls.
The tool calls generated by the model, such as function calls.
class ChatCompletionMessageFunctionToolCall: …A call to a function tool created by the model.
A call to a function tool created by the model.
function: FunctionThe function that the model called.
The function that the model called.
class ChatCompletionMessageFunctionToolCall: …A call to a function tool created by the model.
A call to a function tool created by the model.
function: FunctionThe function that the model called.
The function that the model called.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
class ChatCompletionDeveloperMessageParam: …Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, developer messages
replace the previous system messages.
class ChatCompletionSystemMessageParam: …Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, use developer messages
for this purpose instead.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, use developer messages
for this purpose instead.
class ChatCompletionUserMessageParam: …Messages sent by an end user, containing prompts or additional context
information.
Messages sent by an end user, containing prompts or additional context information.
The contents of the user message.
The contents of the user message.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text, image, or audio inputs.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text, image, or audio inputs.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
class ChatCompletionContentPartImage: …Learn about image inputs.
Learn about image inputs.
image_url: ImageURL
detail: Optional[Literal["auto", "low", "high"]]Specifies the detail level of the image. Learn more in the Vision guide.
Specifies the detail level of the image. Learn more in the Vision guide.
class ChatCompletionContentPartInputAudio: …Learn about audio inputs.
Learn about audio inputs.
class File: …Learn about file inputs for text generation.
Learn about file inputs for text generation.
class ChatCompletionAssistantMessageParam: …Messages sent by the model in response to user messages.
Messages sent by the model in response to user messages.
audio: Optional[Audio]Data about a previous audio response from the model.
Learn more.
Data about a previous audio response from the model. Learn more.
content: Optional[Union[str, List[ContentArrayOfContentPart], null]]The contents of the assistant message. Required unless tool_calls or function_call is specified.
The contents of the assistant message. Required unless tool_calls or function_call is specified.
List[ContentArrayOfContentPart]An array of content parts with a defined type. Can be one or more of type text, or exactly one of type refusal.
An array of content parts with a defined type. Can be one or more of type text, or exactly one of type refusal.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
Deprecatedfunction_call: Optional[FunctionCall]Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
Deprecated and replaced by tool_calls. The name and arguments of a function that should be called, as generated by the model.
An optional name for the participant. Provides the model information to differentiate between participants of the same role.
The tool calls generated by the model, such as function calls.
The tool calls generated by the model, such as function calls.
class ChatCompletionMessageFunctionToolCall: …A call to a function tool created by the model.
A call to a function tool created by the model.
function: FunctionThe function that the model called.
The function that the model called.
A call to a function tool created by the model.
A call to a function tool created by the model.
class ChatCompletionMessageFunctionToolCall: …A call to a function tool created by the model.
A call to a function tool created by the model.
function: FunctionThe function that the model called.
The function that the model called.
class ChatCompletionPredictionContent: …Static predicted output content, such as the content of a text file that is
being regenerated.
Static predicted output content, such as the content of a text file that is being regenerated.
The content that should be matched when generating a model response.
If generated tokens would match this content, the entire model response
can be returned much more quickly.
The content that should be matched when generating a model response. If generated tokens would match this content, the entire model response can be returned much more quickly.
The content used for a Predicted Output. This is often the text of a file you are regenerating with minor changes.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text inputs.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text inputs.
class ChatCompletionStoreMessage: …A chat completion message generated by the model.
A chat completion message generated by the model.
content_parts: Optional[List[ChatCompletionStoreMessageContentPart]]If a content parts array was provided, this is an array of text and image_url parts.
Otherwise, null.
If a content parts array was provided, this is an array of text and image_url parts.
Otherwise, null.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
class ChatCompletionContentPartImage: …Learn about image inputs.
Learn about image inputs.
image_url: ImageURL
detail: Optional[Literal["auto", "low", "high"]]Specifies the detail level of the image. Learn more in the Vision guide.
Specifies the detail level of the image. Learn more in the Vision guide.
class ChatCompletionStreamOptions: …Options for streaming response. Only set this when you set stream: true.
Options for streaming response. Only set this when you set stream: true.
When true, stream obfuscation will be enabled. Stream obfuscation adds
random characters to an obfuscation field on streaming delta events to
normalize payload sizes as a mitigation to certain side-channel attacks.
These obfuscation fields are included by default, but add a small amount
of overhead to the data stream. You can set include_obfuscation to
false to optimize for bandwidth if you trust the network links between
your application and the OpenAI API.
If set, an additional chunk will be streamed before the data: [DONE]
message. The usage field on this chunk shows the token usage statistics
for the entire request, and the choices field will always be an empty
array.
All other chunks will also include a usage field, but with a null
value. NOTE: If the stream is interrupted, you may not receive the
final usage chunk which contains the total token usage for the request.
class ChatCompletionSystemMessageParam: …Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, use developer messages
for this purpose instead.
Developer-provided instructions that the model should follow, regardless of
messages sent by the user. With o1 models and newer, use developer messages
for this purpose instead.
class ChatCompletionTokenLogprob: …
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
The log probability of this token, if it is within the top 20 most likely tokens. Otherwise, the value -9999.0 is used to signify that the token is very unlikely.
top_logprobs: List[TopLogprob]List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
List of the most likely tokens and their log probability, at this token position. In rare cases, there may be fewer than the number of requested top_logprobs returned.
A list of integers representing the UTF-8 bytes representation of the token. Useful in instances where characters are represented by multiple tokens and their byte representations must be combined to generate the correct text representation. Can be null if there is no bytes representation for the token.
A function tool that can be used to generate a response.
A function tool that can be used to generate a response.
class ChatCompletionCustomTool: …A custom tool that processes input using a specified format.
A custom tool that processes input using a specified format.
Controls which (if any) tool is called by the model.
none means the model will not call any tool and instead generates a message.
auto means the model can pick between generating a message or calling one or more tools.
required means the model must call one or more tools.
Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.
none is the default when no tools are present. auto is the default if tools are present.
Controls which (if any) tool is called by the model.
none means the model will not call any tool and instead generates a message.
auto means the model can pick between generating a message or calling one or more tools.
required means the model must call one or more tools.
Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.
none is the default when no tools are present. auto is the default if tools are present.
Literal["none", "auto", "required"]none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.
class ChatCompletionAllowedToolChoice: …Constrains the tools available to the model to a pre-defined set.
Constrains the tools available to the model to a pre-defined set.
class ChatCompletionUserMessageParam: …Messages sent by an end user, containing prompts or additional context
information.
Messages sent by an end user, containing prompts or additional context information.
The contents of the user message.
The contents of the user message.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text, image, or audio inputs.
An array of content parts with a defined type. Supported options differ based on the model being used to generate the response. Can contain text, image, or audio inputs.
class ChatCompletionContentPartText: …Learn about text inputs.
Learn about text inputs.
class ChatCompletionContentPartImage: …Learn about image inputs.
Learn about image inputs.
image_url: ImageURL
detail: Optional[Literal["auto", "low", "high"]]Specifies the detail level of the image. Learn more in the Vision guide.
Specifies the detail level of the image. Learn more in the Vision guide.
class ChatCompletionContentPartInputAudio: …Learn about audio inputs.
Learn about audio inputs.
class File: …Learn about file inputs for text generation.
Learn about file inputs for text generation.
class ChatCompletionAllowedTools: …Constrains the tools available to the model to a pre-defined set.
Constrains the tools available to the model to a pre-defined set.
mode: Literal["auto", "required"]Constrains the tools available to the model to a pre-defined set.
auto allows the model to pick from among the allowed tools and generate a
message.
required requires the model to call one or more of the allowed tools.
Constrains the tools available to the model to a pre-defined set.
auto allows the model to pick from among the allowed tools and generate a
message.
required requires the model to call one or more of the allowed tools.
A list of tool definitions that the model should be allowed to call.
For the Chat Completions API, the list of tool definitions might look like:
[
{ "type": "function", "function": { "name": "get_weather" } },
{ "type": "function", "function": { "name": "get_time" } }
]ChatCompletionsMessages
Given a list of messages comprising a conversation, the model will return a response.